EDIT - feature request #9009

Add structure to store media metadata
05/11/2020 05:02 PM - Andreas Kohlbecker

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Andreas Muller % Done: 100%
Category: cdm Estimated time: 0:00 hour
Target version: CDM UML 5.15

Severity: normal

Description

Media files can contain metadata (Exif, IPCT, PhotoshopMetadata, etc). The Cdm needs to be able to store data extracted from a
media file to avoid fetching and analyzingthe file each time it's metadata is requested.

The data structure will be a cache for

ImageInfo info = new ImageInfo (URI imageUri);
info.getMetaData() ;

info.getWidth () ;

info.getHeight () ;

// etc

Since the Imagelnfo is fetched for each media URI individually the metadata cache should also extend the MediaRepresentationPart.
Structure of the metadata could be a flat key/value pair list like a Map<String,String>.

Now that Imagelnfo and Medialnfo are returning also typed information like width, height, etc it could beneficial to use typed keys and
predefined keys with specific types for e.g. with, length, etc ...:

public class MetaDataMap extends HashMap<MetaDataType<T>, T>{
public static class MetaDataType<T extends Object> {

public static final MetaDataType<String> stringType = new MetaDataType<String> (String.
class);

public static final MetaDataType<Integer> integerType = new MetaDataType<Integer> (Integer.
class);

public static final MetaDataType<Double> doubleType = new MetaDataType<Double> (Double.
class);

Class<T> type;
T value;

private MetaDataType (Class<T> type) {
this.type = type;

public void setValue (T value) {
this.value = value;

}
public T getValue() {

return value;

public Class<T> getType () {
return type;

}

public boolean hasType (Class otherType) {
return type.equals (otherType);
enum MetaDataKey {
WIDTH (MetaDataMap.MetaDataType.stringType),
HEIGHT (MetaDataMap.MetaDataType.integerType),
DURATION (MetaDataMap.MetaDataType.doubleType) ;

MetaDataType<?> type;

private MetaDataKey (MetaDataMap.MetaDataType<?> type) {
this.type = type;

Associated revisions

Revision 72032e83 - 06/10/2020 05:37 PM - Andreas Miiller
fix #9009 add MediaMetaData

Revision 8147e611 - 06/10/2020 05:37 PM - Andreas Miiller
fix #9009 add MediaMetaData (cont.)

Revision 66f2a16f - 06/10/2020 11:09 PM - Andreas Miiller
fix #9009 fixing test schemas for MediaMetaData

Revision e59aa8bb - 07/02/2020 08:59 AM - Andreas Kohlbecker
ref #9009 updating class doc regarding auditing

History

#1 - 05/11/2020 05:27 PM - Andreas Miiller
- Target version changed from CDM UML 5.5 to CDM UML 5.15

#2 - 05/11/2020 05:27 PM - Andreas Miiller
- Priority changed from New to Highest

#3 - 05/26/2020 11:48 AM - Andreas Miiller

as size information like width and height is already stored in MediaRepresentationPart it is not necessary to store such data in the new class. A pure
String based key-value implementation extending CdmBase should be enought. Also versioning is not necessary as the data should be available from
the external files if necessary.

#4 - 06/10/2020 02:57 PM - Andreas Miuller

- Status changed from New to In Progress

#5 - 06/10/2020 05:38 PM - Andreas Miiller
- Status changed from In Progress to Resolved

- % Done changed from 0 to 50

Applied in changeset cdmlib|72032e8369286b8e52207a4ed1ed0443e416b72a.

#6 - 06/15/2020 08:57 PM - Andreas Miiller
- Assignee changed from Andreas Muiller to Andreas Kohlbecker

- % Done changed from 50 to 0

Please review

#7 - 07/02/2020 09:00 AM - Andreas Kohlbecker

- Status changed from Resolved to Closed
https://dev.e-taxonomy.eu/redmine/projects/edit/repository/cdmlib/revisions/72032e8369286b8e52207a4ed1ed0443e416b72a

- Assignee changed from Andreas Kohlbecker to Andreas Miiller

- % Done changed from 0 to 100

The type level java doc regarding auditing was not up to date. | changed this and the ticket can be closed.
